//-----------------------------------------------------------------------------
//    API_2_ENH_COPY_BSS_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_copy_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;
import javacard.framework.Util.* ;
/**
 * Test Area : sim.tookit.EnvelopeHandler.copy()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ENH_COPY_BSS_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    //private ToolkitRegistry obReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

	private static byte[] CmpBuffer = {  (byte)0x82, (byte)0x02 ,(byte)0x83 ,(byte)0x81 ,(byte)0x8B ,(byte)0x29 ,(byte)0x40 ,(byte)0x08 ,(byte)0x81 ,(byte)0x55 ,(byte)0x66 ,(byte)0x77 ,(byte)0x88 ,(byte)0x7F ,(byte)0xF6 ,(byte)0x00
										,(byte)0x11 ,(byte)0x29 ,(byte)0x12 ,(byte)0x00 ,(byte)0x00 ,(byte)0x04 ,(byte)0x18 ,(byte)0x02 ,(byte)0x70 ,(byte)0x00 ,(byte)0x00 ,(byte)0x13 ,(byte)0x0D ,(byte)0x08 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x28 ,(byte)0x82 ,(byte)0x05 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x01 ,(byte)0x00 ,(byte)0x01 ,(byte)0x02 ,(byte)0x03 ,(byte)0x04 ,(byte)0x05};
										
										
	private static byte[] CmpBuffer2 = { (byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x82, (byte)0x02 ,(byte)0x83 ,(byte)0x81 ,(byte)0x8B ,(byte)0x29 ,(byte)0x40 ,(byte)0x08 ,(byte)0x81 ,(byte)0x55 ,(byte)0x66 ,(byte)0x77 ,(byte)0x88 
										,(byte)0x7F ,(byte)0xF6 ,(byte)0x00	,(byte)0x11 ,(byte)0x29 ,(byte)0x12 ,(byte)0x00 ,(byte)0x00 ,(byte)0x04 ,(byte)0x18 ,(byte)0x02 ,(byte)0x70 ,(byte)0x00 ,(byte)0x00 ,(byte)0x13 ,(byte)0x0D
										,(byte)0x08 ,(byte)0x00 ,(byte)0x00	,(byte)0x00 ,(byte)0x28 ,(byte)0x82 ,(byte)0x05 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x01 ,(byte)0x00 ,(byte)0x01 ,(byte)0x02 ,(byte)0x03 
										,(byte)0x04 ,(byte)0x05};
										
	private static byte[] CmpBuffer3 = { (byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x82, (byte)0x02 ,(byte)0x83 ,(byte)0x81 ,(byte)0x8B ,(byte)0x29 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00};
	
	private static byte[] CmpBuffer4 = { (byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00 ,(byte)0x00
										,(byte)0x00 ,(byte)0x82, (byte)0x02 ,(byte)0x83  };
	
	private static EnvelopeHandler envHdlr3;
	private EnvelopeHandler envHdlr4;

	private byte[] dstBuffer;

    // Number of tests
    byte testCaseNb = (byte) 0x00;
    byte testCaseSubNb =(byte) 0x01;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_COPY_BSS_1 () 
    {
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_COPY_BSS_1  thisApplet = new API_2_ENH_COPY_BSS_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
		ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
			case (byte) 0 : 
				// --------------------------------------------
				// Test Case 1 : the destination buffer is null
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					envHdlr.copy(null,(short)0,envHdlr.getLength());
						bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (NullPointerException e)    {
					bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : the destination offset is > to the buffer length
				testCaseNb = (byte) 2 ;

				dstBuffer = new byte[5];
				bRes = false ;
				try {
					envHdlr.copy(dstBuffer,(short)5,(short)1);
						bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {
					bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : the destination offset is <0
				testCaseNb = (byte) 3 ;

				dstBuffer = new byte[5];
				bRes = false ;
				try {
					envHdlr.copy(dstBuffer,(short)(-1),(short)1);
						bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {
					bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : the destination length is bigger to the buffer length
				testCaseNb = (byte) 4 ;

				dstBuffer = new byte[5];
				bRes = false ;
				try {
					envHdlr.copy(dstBuffer,(short)0,(short)6);
						bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {
					bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 4 :
				// --------------------------------------------
				// Test Case 5 : the destination offset + length is bigger to the buffer length
				testCaseNb = (byte) 5 ;

				dstBuffer = new byte[5];
				bRes = false ;
				try {
					envHdlr.copy(dstBuffer,(short)3,(short)3);
						bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {
					bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : the destination length is <0
				testCaseNb = (byte) 6 ;

				dstBuffer = new byte[5];
				bRes = false ;
				try {
					envHdlr.copy(dstBuffer,(short)0,(short)(-1));
						bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {
					bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : the destination length is > TLV length
				testCaseNb = (byte) 7 ;

				dstBuffer = new byte[48];
				bRes = false ;
				try {
					envHdlr.copy(dstBuffer,(short)0,(short)48);
						bRes = false;
				}
				catch (ToolkitException e)    {
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;		

			case (byte) 7 :
				// --------------------------------------------
				// Test Case 8 : 
				testCaseNb = (byte) 8 ;

				dstBuffer = new byte[47];
				bRes = false ;
				try {
					if(envHdlr.copy(dstBuffer,(short)0,(short)47)==0x002F)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 8 :
				// --------------------------------------------
				// Test Case 9 : compare the buffer
				testCaseNb = (byte) 9 ;

				dstBuffer = new byte[47];
				bRes = false ;
				try {
					if((envHdlr.copy(dstBuffer,(short)0,(short)47)==0x002F)
						&&(Util.arrayCompare(dstBuffer,(short)0,CmpBuffer,(short)0,(short)CmpBuffer.length))==0)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 9 :
				// --------------------------------------------
				// Test Case 10 : copy in a part of the buffer
				testCaseNb = (byte) 10 ;

				dstBuffer = new byte[50];
				bRes = false ;
				try {
					if(envHdlr.copy(dstBuffer,(short)3,(short)47)==0x0032)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 10 :
				// --------------------------------------------
				// Test Case 11 : compare the whole buffer
				testCaseNb = (byte) 11 ;

				dstBuffer = new byte[50];
				bRes = false ;
				try {
					if((envHdlr.copy(dstBuffer,(short)3,(short)47)==0x0032)
						&&(Util.arrayCompare(dstBuffer,(short)0,CmpBuffer2,(short)0,(short)CmpBuffer2.length))==0)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			case (byte) 11 :
				// --------------------------------------------
				// Test Case 12 : copy in a part of the buffer
				testCaseNb = (byte) 12 ;

				dstBuffer = new byte[15];
				bRes = false ;
				try {
					if(envHdlr.copy(dstBuffer,(short)3,(short)6)==0x0009)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 12 :
				// --------------------------------------------
				// Test Case 13 : compare the whole buffer
				testCaseNb = (byte) 13 ;

				dstBuffer = new byte[15];
				bRes = false ;
				try {
					if((envHdlr.copy(dstBuffer,(short)3,(short)6)==0x0009)
						&&(Util.arrayCompare(dstBuffer,(short)0,CmpBuffer3,(short)0,(short)CmpBuffer3.length))==0)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			case (byte) 13 :
				// --------------------------------------------
				// Test Case 14 : copy in a part of the buffer
				testCaseNb = (byte) 14 ;

				dstBuffer = new byte[260];
				bRes = false ;
				try {
					if(envHdlr.copy(dstBuffer,(short)257,(short)3)==0x0104)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 14 :
				// --------------------------------------------
				// Test Case 15 : compare the whole buffer
				testCaseNb = (byte) 15 ;

				dstBuffer = new byte[260];
				bRes = false ;
				try {
					if((envHdlr.copy(dstBuffer,(short)257,(short)3)==0x0104)
						&&(Util.arrayCompare(dstBuffer,(short)0,CmpBuffer4,(short)0,(short)CmpBuffer4.length))==0)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 15 :
				// --------------------------------------------
				// Test Case 16 : successful call with the length=0 and the offset = length of the destination buffer
				testCaseNb = (byte) 16 ;

				bRes = false ;
				try {
					if(envHdlr.copy(dstBuffer,(short)dstBuffer.length,(short)0)==dstBuffer.length)
						bRes = true;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		}
	}
}
